// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.
#include <utility>

// Container for a key-value pair
template <typename Key, typename E>
class KVpair
{
    private:
        Key k;
        E e;

    public:
        // Constructors
        KVpair() {}

        KVpair(Key kval, E eval)
        {
            k = kval;
            e = eval;
        }

        KVpair(const KVpair &source)  // Copy constructor
        {
            k = source.k;
            e = source.e;
        }

        // is not typically void, if you want to do chaining.
        void operator=(const KVpair &source) // Assignment operator
        {
            k = source.k;
            e = source.e;
        }

        // Data member access functions
        Key key()
        {
            return k;
        }

        void setKey(Key ink)
        {
            k = ink;
        }

        E value()
        {
            return e;
        }
};
