// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Test program for the dictionary class implemented using an
// unsorted array-based list

#include "book.h"

// Use an array-based list implementation

//#include "SALdict.h"
#include "UALdict.h"

// A simple payroll entry with ID, name, address fields
class Payroll
{
    private:
        int ID;
        string name;
        string address;

    public:
        // Constructor
        Payroll(int inID, string inname, string inaddr)
        {
            ID = inID;
            name = inname;
            address = inaddr;
        }

        Payroll() {}
        // Destructor

        // Local data member access functions
        int getID()
        {
            return ID;
        }

        string getname()
        {
            return name;
        }

        string getaddr()
        {
            return address;
        }
};


// Driver for testing unsorted array-based dictionary
int main()
{
    // IDdict organizes Payroll records by ID
    //SALdict<int, Payroll*> IDdict;
    UALdict<int, Payroll *> IDdict;

    // namedict organizes Payroll records by name
    UALdict<string, Payroll *> namedict;

    Payroll *foo1, *foo2, *findfoo1, *findfoo2;

    foo1 = new Payroll(5, "Joe", "Anytown");
    foo2 = new Payroll(10, "John", "Mytown");

    IDdict.insert(foo1->getID(), foo1);
    IDdict.insert(foo2->getID(), foo2);

    namedict.insert(foo1->getname(), foo1);
    namedict.insert(foo2->getname(), foo2);

    findfoo1 = IDdict.find(5);

    if(findfoo1 != nullptr)
        cout << "Finding ID#: " << findfoo1->getID() <<
             " bound to name: " << findfoo1->getname() <<
             " and address: " << findfoo1->getaddr() << endl;
    else
        cout << "nullptr ";

    findfoo2 = namedict.find("John");

    if(findfoo2 != nullptr)
        cout << "Finding name#: " << findfoo1->getname() <<
             " bound to ID#: " << findfoo1->getID() <<
             " and address: " << findfoo1->getaddr() << endl;
    else
        cout << "nullptr ";

    cout << "Removing ID#: " << IDdict.remove(5)->getID() << endl;

    cout << "Removing name#: " << namedict.remove("John")->getname() << endl;

    return 0;
}
